/* vim:set ts=4: */

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	"svclient.h"

#ifdef	WIN32
#include	<winsock.h>
#include	<windows.h>
#define		IsError(n)		(n == SOCKET_ERROR)
#define		CloseSocket(n)	closesocket(n)
typedef		int				socklen_t;
#endif	// WIN32

#ifdef	UNIX
#include	<unistd.h>
#include	<netdb.h>
#include	<sys/time.h>
#include	<sys/socket.h>
#include	<netinet/in.h>
#include	<arpa/inet.h>
#define		IsError(n)		(n < 0)
#define		CloseSocket(n)	close(n)
typedef		int				SOCKET;
#ifdef	linux
typedef		unsigned int	socklen_t;
#else
typedef		int				socklen_t;
#endif	// linux
#endif	// UNIX

int
main(int argc,char **argv)
{
	unsigned long		ip		= inet_addr(argv[1]);
	unsigned char		cmd		= CMD_GET;
	socklen_t			addrlen	= sizeof(struct sockaddr_in);
	struct sockaddr_in	addr;
	SOCKET				sock;
	int					ret		= 0;

	HDTEMP				HDTemp[MAXDEVICE];	// MAXDEVICE̔zŗp
	char				*data	= 0;
	unsigned int		datalen	= 0;

#ifdef	WIN32
	WSADATA			wsadata;
	if( WSAStartup(MAKEWORD(0x01,0x01),&wsadata) != 0 )
	{
		printf("WSAStartup() error.\n");
		return( -1 );
	}
#endif
	sock	= socket(AF_INET,SOCK_DGRAM,IPPROTO_UDP);
	if( IsError(sock) )
	{
		printf("socket() error.\n");
		return( -1 );
	}
	memset((char*)&addr,0x00,addrlen);
	addr.sin_family			= AF_INET;
	addr.sin_addr.s_addr	= ip;
	addr.sin_port			= htons(SVC_PORT);

	data	= (char*)&cmd;
	datalen	= sizeof(unsigned char);
	if( sendto(sock,data,datalen,0,(struct sockaddr*)&addr,addrlen) != (int)datalen )
	{
		printf("sendto() error.\n");
		return( -1 );
	}

	data	= (char*)&HDTemp;
	datalen	= sizeof(HDTemp);
	ret	= recvfrom(sock,data,datalen,0,(struct sockaddr*)&addr,&addrlen);
	if( IsError(ret) )
	{
		printf("recvfrom() error.\n");
		return( -1 );
	}

	for( int i = 0 ; i < MAXDEVICE ; i++ )
	{
		if( HDTemp[i].Ready == RDY_OK )
		{
			printf("#%-2u %2u/%2u : %s (%s %s)\n",i,HDTemp[i].TempCur,HDTemp[i].TempMax,
				HDTemp[i].szModelNumber,HDTemp[i].szFirmwareRev,HDTemp[i].szSerialNumber);
		}
	}

	CloseSocket(sock);

#ifdef	WIN32
	if( WSACleanup() != 0 )
	{
		printf("WSACleanup() error.\n");
		return( -1 );
	}
#endif

	return( 0 );
}
